from scrapy.selector import HtmlXPathSelector
from scrapy.contrib.linkextractors.sgml import SgmlLinkExtractor
from scrapy.contrib.spiders import CrawlSpider, Rule
from duoduo.items import DuoduoItem
from scrapy.conf import settings

class D360Spider(CrawlSpider):
    name = 'd360'
    allowed_domains = ['360buy.com']
    start_urls = ['http://www.360buy.com']
    #603122.html
    rules = (
        Rule(SgmlLinkExtractor(allow=('product/\d{6,6}\.html',)), callback='parse_item', follow=True, process_links='pro_links', process_request='pro_request'),
    )
    testOne = 2

    def parse_item(self, response):
        self.log('Hi, this is an item page! %s' % response.url)

        hxs = HtmlXPathSelector(response)
        i = DuoduoItem()
        #i['domain_id'] = hxs.select('//input[@id="sid"]/@value').extract()
        i['title'] = hxs.select('//div[@id="detail"]/div/ul[@id="i-detail"]/li/@title').extract()
        i['priceimgsrc'] = hxs.select('//*[@id="summary"]/li[2]/div[1]/strong/img/@src').extract()
        #i['description'] = hxs.select('//div[@id="description"]').extract()
        return i

    def pro_links(self, links):
        self.log('process links {0:d}'.format(len(links)))
#        for link in links:
#            self.log(link.url)
        return links

    def pro_request(self, request):
 #       self.log('process request %s' % request.url)
        if self.testOne > 0: 
            self.testOne = self.testOne - 1
            self.log('do it nowwwww')
            return self.make_requests_from_url(request.url)
        return None
    
